diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/dwca/out/DwcaVernacularRecord.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/dwca/out/DwcaVernacularRecord.java
index 0e66863061..00ce8af7fa 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/dwca/out/DwcaVernacularRecord.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/dwca/out/DwcaVernacularRecord.java
@@ -15,9 +15,8 @@ import java.net.URISyntaxException;
 import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.io.dwca.TermUri;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.description.Sex;
-import eu.etaxonomy.cdm.model.description.Stage;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 
 /**
@@ -36,8 +35,8 @@ public class DwcaVernacularRecord extends DwcaRecordBase implements IDwcaAreaRec
 	private DwcaId locationId;
 	private String locality;
 	private String countryCode;
-	private Sex sex;
-	private Stage lifeStage;
+	private DefinedTerm sex;
+	private DefinedTerm lifeStage;
 	private Boolean isPlural;
 	private Boolean isPreferredName;
 	private String organismPart;
@@ -175,12 +174,12 @@ public class DwcaVernacularRecord extends DwcaRecordBase implements IDwcaAreaRec
 	}
 
 
-	public Stage getLifeStage() {
+	public DefinedTerm getLifeStage() {
 		return lifeStage;
 	}
 
 
-	public void setLifeStage(Stage lifeStage) {
+	public void setLifeStage(DefinedTerm lifeStage) {
 		this.lifeStage = lifeStage;
 	}
 
@@ -194,12 +193,12 @@ public class DwcaVernacularRecord extends DwcaRecordBase implements IDwcaAreaRec
 		this.locationId.setId(locationId);
 	}
 	
-	public Sex getSex() {
+	public DefinedTerm getSex() {
 		return sex;
 	}
 
 
-	public void setSex(Sex sex) {
+	public void setSex(DefinedTerm sex) {
 		this.sex = sex;
 	}
 
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelImporterBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelImporterBase.java
index 21b454ed1a..5c4a44ba87 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelImporterBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelImporterBase.java
@@ -23,6 +23,7 @@ import eu.etaxonomy.cdm.common.ExcelUtils;
 import eu.etaxonomy.cdm.io.common.CdmImportBase;
 import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 /**
  * @author a.babadshanjan
@@ -184,7 +185,7 @@ public abstract class ExcelImporterBase<STATE extends ExcelImportState<? extends
 	 */
 	protected TimePeriod getTimePeriod(String start, String end) {
 		String strPeriod = CdmUtils.concat(" - ", start, end);
-		TimePeriod result = TimePeriod.parseString(strPeriod);
+		TimePeriod result = TimePeriodParser.parseString(strPeriod);
 		return result;
 	}
 
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelRowBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelRowBase.java
index c2310e44d5..9a35515aae 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelRowBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/common/ExcelRowBase.java
@@ -21,6 +21,7 @@ import org.apache.log4j.Logger;
 
 import eu.etaxonomy.cdm.io.excel.common.ExcelTaxonOrSpecimenImportBase.SourceType;
 import eu.etaxonomy.cdm.model.common.IdentifiableSource;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignation;
 import eu.etaxonomy.cdm.model.name.SpecimenTypeDesignationStatus;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
@@ -169,7 +170,7 @@ public abstract class ExcelRowBase {
 	private IdentifiableSource getOrMakeSource(int key) {
 		IdentifiableSource  source = sources.get(key);
 		if (source == null){
-			source = IdentifiableSource.NewInstance();
+			source = IdentifiableSource.NewInstance(OriginalSourceType.Unknown);
 			sources.put(key, source);
 		}
 		return source;
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/distribution/DistributionImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/distribution/DistributionImport.java
index 2bcdda0b94..991e06fb5b 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/distribution/DistributionImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/distribution/DistributionImport.java
@@ -26,6 +26,7 @@ import eu.etaxonomy.cdm.common.CdmUtils;
 import eu.etaxonomy.cdm.common.ExcelUtils;
 import eu.etaxonomy.cdm.io.common.CdmIoBase;
 import eu.etaxonomy.cdm.io.common.ICdmIO;
+import eu.etaxonomy.cdm.io.common.TdwgAreaProvider;
 import eu.etaxonomy.cdm.io.excel.common.ExcelImportConfiguratorBase;
 import eu.etaxonomy.cdm.io.excel.common.ExcelImportState;
 import eu.etaxonomy.cdm.io.excel.common.ExcelRowBase;
@@ -35,7 +36,6 @@ import eu.etaxonomy.cdm.model.description.PresenceAbsenceTermBase;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.persistence.query.MatchMode;
@@ -229,7 +229,7 @@ public class DistributionImport extends CdmIoBase<ExcelImportState<ExcelImportCo
         				boolean ignore = false;
         				
     					if(!distribution.equals("")) {
-    						NamedArea namedArea = TdwgArea.getAreaByTdwgAbbreviation(distribution);
+    						NamedArea namedArea = TdwgAreaProvider.getAreaByTdwgAbbreviation(distribution);
         					TaxonDescription taxonDescription = myDescriptions.get(taxon);
         					if (namedArea != null) {    
     		    				// Check against existing distributions and ignore the ones that occur multiple times
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/taxa/NormalExplicitImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/taxa/NormalExplicitImport.java
index 0e27919a47..d6b2322cde 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/taxa/NormalExplicitImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/excel/taxa/NormalExplicitImport.java
@@ -25,17 +25,18 @@ import org.apache.log4j.Logger;
 import org.springframework.stereotype.Component;
 
 import eu.etaxonomy.cdm.common.CdmUtils;
+import eu.etaxonomy.cdm.io.common.TdwgAreaProvider;
 import eu.etaxonomy.cdm.io.excel.common.ExcelRowBase.SourceDataHolder;
 import eu.etaxonomy.cdm.model.agent.Team;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.CdmBase;
-import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
 import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.Language;
-import eu.etaxonomy.cdm.model.common.TimePeriod;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.DescriptionElementSource;
 import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
@@ -43,7 +44,6 @@ import eu.etaxonomy.cdm.model.description.TaxonDescription;
 import eu.etaxonomy.cdm.model.description.TaxonNameDescription;
 import eu.etaxonomy.cdm.model.description.TextData;
 import eu.etaxonomy.cdm.model.location.NamedArea;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.NomenclaturalCode;
 import eu.etaxonomy.cdm.model.name.NonViralName;
@@ -59,6 +59,7 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.strategy.exceptions.StringNotParsableException;
 import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
 import eu.etaxonomy.cdm.strategy.parser.NonViralNameParserImpl;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 /**
  * @author a.babadshanjan
@@ -162,7 +163,7 @@ public class NormalExplicitImport extends TaxonExcelImporterBase {
 
 				// Rank
 				try {
-					rank = Rank.getRankByNameOrAbbreviation(rankStr);
+					rank = Rank.getRankByNameOrIdInVoc(rankStr);
 				} catch (UnknownCdmTypeException ex) {
 					try {
 						rank = Rank.getRankByEnglishName(rankStr, state.getConfig().getNomenclaturalCode(), false);
@@ -324,9 +325,9 @@ public class NormalExplicitImport extends TaxonExcelImporterBase {
 				//tdwg label
 				for (String tdwg : taxonDataHolder.getDistributions()){
 					TaxonDescription td = this.getTaxonDescription(acceptedTaxon, state.getConfig().getSourceReference() ,false, true);
-					NamedArea area = TdwgArea.getAreaByTdwgAbbreviation(tdwg);
+					NamedArea area = TdwgAreaProvider.getAreaByTdwgAbbreviation(tdwg);
 					if (area == null){
-						area = TdwgArea.getAreaByTdwgLabel(tdwg);
+						area = TdwgAreaProvider.getAreaByTdwgLabel(tdwg);
 					}
 					if (area != null){
 						Distribution distribution = Distribution.NewInstance(area, PresenceTerm.PRESENT());
@@ -374,25 +375,25 @@ public class NormalExplicitImport extends TaxonExcelImporterBase {
 				List<Map<SourceType, String>> sourceList = sourceDataHolder.getSources();
 				for (Map<SourceType, String> sourceMap : sourceList){
 				
-					DescriptionElementSource source = DescriptionElementSource.NewInstance();
 					//ref
 					Reference<?> ref = ReferenceFactory.newGeneric();
 					boolean refExists = false; //in case none of the ref fields exists, the ref should not be added
 					for (SourceType type : sourceMap.keySet()){
 						String value = sourceMap.get(type);
 						if (type.equals(SourceType.Author)){
-							TeamOrPersonBase author = getAuthorAccordingToConfig(value, state);
+							TeamOrPersonBase<?> author = getAuthorAccordingToConfig(value, state);
 							ref.setAuthorTeam(author);
 						}else if (type.equals(SourceType.Title)) {
 							ref.setTitle(value);
 						}else if (type.equals(SourceType.Year)) {
-							ref.setDatePublished(TimePeriod.parseString(value));
+							ref.setDatePublished(TimePeriodParser.parseString(value));
 						}else if (type.equals(SourceType.RefExtension)) {
 							ExtensionType extensionType = getExtensionType(state, uuidRefExtension, "RefExtension", "Reference Extension", "RefExt.");
 							Extension extension = Extension.NewInstance(ref, value, extensionType);
 						}
 						refExists = true;
 					}
+					DescriptionElementSource source = DescriptionElementSource.NewInstance(OriginalSourceType.PrimaryTaxonomicSource);
 					if (refExists){
 						ref = getReferenceAccordingToConfig(ref, state);
 						source.setCitation(ref);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/jaxb/DataSet.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/jaxb/DataSet.java
index ea62ee5e21..7e369a264a 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/jaxb/DataSet.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/jaxb/DataSet.java
@@ -25,14 +25,13 @@ import org.springframework.security.core.GrantedAuthority;
 
 import eu.etaxonomy.cdm.model.agent.AgentBase;
 import eu.etaxonomy.cdm.model.agent.Institution;
-import eu.etaxonomy.cdm.model.agent.InstitutionType;
 import eu.etaxonomy.cdm.model.agent.Person;
 import eu.etaxonomy.cdm.model.agent.Team;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.EventBase;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
-import eu.etaxonomy.cdm.model.common.Figure;
 import eu.etaxonomy.cdm.model.common.GrantedAuthorityImpl;
 import eu.etaxonomy.cdm.model.common.Group;
 import eu.etaxonomy.cdm.model.common.Language;
@@ -46,23 +45,18 @@ import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.FeatureTree;
 import eu.etaxonomy.cdm.model.description.MeasurementUnit;
 import eu.etaxonomy.cdm.model.description.MediaKey;
-import eu.etaxonomy.cdm.model.description.Modifier;
 import eu.etaxonomy.cdm.model.description.PolytomousKey;
 import eu.etaxonomy.cdm.model.description.PresenceTerm;
-import eu.etaxonomy.cdm.model.description.Scope;
-import eu.etaxonomy.cdm.model.description.Sex;
-import eu.etaxonomy.cdm.model.description.Stage;
 import eu.etaxonomy.cdm.model.description.State;
 import eu.etaxonomy.cdm.model.description.StatisticalMeasure;
 import eu.etaxonomy.cdm.model.description.TextFormat;
-import eu.etaxonomy.cdm.model.location.Continent;
+import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
 import eu.etaxonomy.cdm.model.location.ReferenceSystem;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
-import eu.etaxonomy.cdm.model.location.WaterbodyOrCountry;
+import eu.etaxonomy.cdm.model.location.Country;
 import eu.etaxonomy.cdm.model.media.Media;
-import eu.etaxonomy.cdm.model.media.RightsTerm;
+import eu.etaxonomy.cdm.model.media.RightsType;
 import eu.etaxonomy.cdm.model.molecular.DnaSample;
 import eu.etaxonomy.cdm.model.molecular.PhylogeneticTree;
 import eu.etaxonomy.cdm.model.name.BacterialName;
@@ -86,23 +80,18 @@ import eu.etaxonomy.cdm.model.name.ZoologicalName;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEvent;
 import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
 import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
-import eu.etaxonomy.cdm.model.occurrence.DeterminationModifier;
-import eu.etaxonomy.cdm.model.occurrence.FieldObservation;
-import eu.etaxonomy.cdm.model.occurrence.Fossil;
+import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
 import eu.etaxonomy.cdm.model.occurrence.GatheringEvent;
-import eu.etaxonomy.cdm.model.occurrence.LivingBeing;
-import eu.etaxonomy.cdm.model.occurrence.Observation;
 import eu.etaxonomy.cdm.model.occurrence.PreservationMethod;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.reference.Reference;
+import eu.etaxonomy.cdm.model.taxon.Classification;
 import eu.etaxonomy.cdm.model.taxon.Synonym;
 import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 import eu.etaxonomy.cdm.model.taxon.TaxonNode;
 import eu.etaxonomy.cdm.model.taxon.TaxonRelationshipType;
-import eu.etaxonomy.cdm.model.taxon.Classification;
 
 /**
  * @author a.babadshanjan
@@ -137,18 +126,18 @@ public class DataSet {
     @XmlElements({
     	@XmlElement(name = "AbsenceTerm", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = AbsenceTerm.class),
     	@XmlElement(name = "AnnotationType", namespace = "http://etaxonomy.eu/cdm/model/common/1.0", type = AnnotationType.class),
-    	@XmlElement(name = "Continent", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = Continent.class),
+    	@XmlElement(name = "Continent", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = NamedArea.class),
     	@XmlElement(name = "DerivationEventType", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = DerivationEventType.class),
-    	@XmlElement(name = "DeterminationModifier", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = DeterminationModifier.class),
+    	@XmlElement(name = "DeterminationModifier", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = DefinedTerm.class),
     	@XmlElement(name = "ExtensionType", namespace = "http://etaxonomy.eu/cdm/model/common/1.0", type = ExtensionType.class),
     	@XmlElement(name = "Feature", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = Feature.class),
     	@XmlElement(name = "HybridRelationshipType", namespace = "http://etaxonomy.eu/cdm/model/name/1.0", type = HybridRelationshipType.class),
-    	@XmlElement(name = "InstitutionType", namespace = "http://etaxonomy.eu/cdm/model/agent/1.0", type = InstitutionType.class),
+    	@XmlElement(name = "InstitutionType", namespace = "http://etaxonomy.eu/cdm/model/agent/1.0", type = DefinedTerm.class),
     	@XmlElement(name = "Language", namespace = "http://etaxonomy.eu/cdm/model/common/1.0", type = Language.class),
     	@XmlElement(name = "MarkerType", namespace = "http://etaxonomy.eu/cdm/model/common/1.0", type = MarkerType.class),
     	@XmlElement(name = "MeasurementUnit", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = MeasurementUnit.class),
-    	@XmlElement(name = "Modifier", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = Modifier.class),
-    	@XmlElement(name = "NamedArea", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = TdwgArea.class),
+    	@XmlElement(name = "Modifier", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = DefinedTerm.class),
+    	@XmlElement(name = "NamedArea", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = NamedArea.class),
     	@XmlElement(name = "NamedAreaLevel", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = NamedAreaLevel.class),
     	@XmlElement(name = "NamedAreaType", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = NamedAreaType.class),
     	@XmlElement(name = "NameRelationshipType", namespace = "http://etaxonomy.eu/cdm/model/name/1.0", type = NameRelationshipType.class),
@@ -159,18 +148,18 @@ public class DataSet {
     	@XmlElement(name = "PreservationMethod", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = PreservationMethod.class),
         @XmlElement(name = "Rank", namespace = "http://etaxonomy.eu/cdm/model/name/1.0", type = Rank.class),
     	@XmlElement(name = "ReferenceSystem", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = ReferenceSystem.class),
-    	@XmlElement(name = "RightsTerm", namespace = "http://etaxonomy.eu/cdm/model/media/1.0", type = RightsTerm.class),
-    	@XmlElement(name = "Scope", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = Scope.class),
-    	@XmlElement(name = "Sex", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = Sex.class),
+    	@XmlElement(name = "RightsType", namespace = "http://etaxonomy.eu/cdm/model/media/1.0", type = RightsType.class),
+    	@XmlElement(name = "Scope", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = DefinedTerm.class),
+    	@XmlElement(name = "Sex", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = DefinedTerm.class),
     	@XmlElement(name = "SpecimenTypeDesignationStatus", namespace = "http://etaxonomy.eu/cdm/model/name/1.0", type = SpecimenTypeDesignationStatus.class),
-    	@XmlElement(name = "Stage", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = Stage.class),
+    	@XmlElement(name = "Stage", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = DefinedTerm.class),
     	@XmlElement(name = "State", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = State.class),
     	@XmlElement(name = "StatisticalMeasure", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = StatisticalMeasure.class),
     	@XmlElement(name = "SynonymRelationshipType", namespace = "http://etaxonomy.eu/cdm/model/taxon/1.0", type = SynonymRelationshipType.class),
     	@XmlElement(name = "TaxonRelationshipType", namespace = "http://etaxonomy.eu/cdm/model/taxon/1.0", type = TaxonRelationshipType.class),
     	//    	@XmlElement(name = "TdwgArea", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = TdwgArea.class),
     	@XmlElement(name = "TextFormat", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = TextFormat.class),
-    	@XmlElement(name = "WaterbodyOrCountry", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = WaterbodyOrCountry.class)
+    	@XmlElement(name = "Country", namespace = "http://etaxonomy.eu/cdm/model/location/1.0", type = Country.class)
     	
     })
     protected List<DefinedTermBase> terms = new ArrayList<DefinedTermBase>();
@@ -225,11 +214,7 @@ public class DataSet {
     @XmlElements({
     	@XmlElement(name = "DerivedUnit", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = DerivedUnit.class),
     	@XmlElement(name = "DnaSample", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = DnaSample.class),
-    	@XmlElement(name = "FieldObservation", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = FieldObservation.class),
-    	@XmlElement(name = "Fossil", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = Fossil.class),
-    	@XmlElement(name = "LivingBeing", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = LivingBeing.class),
-    	@XmlElement(name = "Observation", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = Observation.class),
-    	@XmlElement(name = "Specimen", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = Specimen.class)
+    	@XmlElement(name = "FieldUnit", namespace = "http://etaxonomy.eu/cdm/model/occurrence/1.0", type = FieldUnit.class)
     })
     protected List<SpecimenOrObservationBase> occurrences = new ArrayList<SpecimenOrObservationBase>();
     
@@ -275,7 +260,6 @@ public class DataSet {
     @XmlElements({
       @XmlElement(name = "Media", namespace = "http://etaxonomy.eu/cdm/model/media/1.0", type = Media.class),
       @XmlElement(name = "MediaKey", namespace = "http://etaxonomy.eu/cdm/model/description/1.0", type = MediaKey.class),
-      @XmlElement(name = "Figure", namespace = "http://etaxonomy.eu/cdm/model/common/1.0", type = Figure.class),
       @XmlElement(name = "PhylogeneticTree", namespace = "http://etaxonomy.eu/cdm/model/molecular/1.0", type = PhylogeneticTree.class)
     })
     protected List<Media> media = new ArrayList<Media>();
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupDocumentImportNoComponent.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupDocumentImportNoComponent.java
index bf69c7c453..537256c602 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupDocumentImportNoComponent.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupDocumentImportNoComponent.java
@@ -30,6 +30,11 @@ import eu.etaxonomy.cdm.io.common.mapping.UndefinedTransformerMethodException;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
+import eu.etaxonomy.cdm.model.common.TermVocabulary;
+import eu.etaxonomy.cdm.model.description.CommonTaxonName;
+import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
+import eu.etaxonomy.cdm.model.description.Distribution;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.PolytomousKey;
 import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;
@@ -236,7 +241,7 @@ public class MarkupDocumentImportNoComponent extends MarkupImportBase {
 		
 		Classification tree = makeTree(state, dataLocation);
 		if (lastTaxon == null) {
-			tree.addChildTaxon(taxon, null, null, null);
+			tree.addChildTaxon(taxon, null, null);
 			return;
 		}
 		Rank thisRank = taxon.getName().getRank();
@@ -252,15 +257,15 @@ public class MarkupDocumentImportNoComponent extends MarkupImportBase {
 				message = String.format(message, taxon.getName().getTitleCache());
 				fireWarningEvent(message, makeLocationStr(dataLocation), 6);
 			}else if (thisRank.isLower(lastRank)) {
-				lastNode.addChildTaxon(taxon, null, null, null);
+				lastNode.addChildTaxon(taxon, null, null);
 				fillMissingEpithetsForTaxa(lastTaxon, taxon);
 			} else if (thisRank.equals(lastRank)) {
 				TaxonNode parent = lastNode.getParent();
 				if (parent != null) {
-					parent.addChildTaxon(taxon, null, null, null);
+					parent.addChildTaxon(taxon, null, null);
 					fillMissingEpithetsForTaxa(parent.getTaxon(), taxon);
 				} else {
-					tree.addChildTaxon(taxon, null, null, null);
+					tree.addChildTaxon(taxon, null, null);
 				}
 			} else if (thisRank.isHigher(lastRank)) {
 				doTaxonRelation(state, taxon, lastNode.getParent().getTaxon(),	dataLocation);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupFeatureImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupFeatureImport.java
index 04a4687fd0..460546640d 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupFeatureImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupFeatureImport.java
@@ -29,6 +29,7 @@ import eu.etaxonomy.cdm.model.common.AnnotatableEntity;
 import eu.etaxonomy.cdm.model.common.Annotation;
 import eu.etaxonomy.cdm.model.common.AnnotationType;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.description.CommonTaxonName;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
@@ -123,7 +124,7 @@ public class MarkupFeatureImport extends MarkupImportBase {
 					TaxonDescription description = getTaxonDescription(taxon, descriptionRef, false, true);
 					TextData featurePlaceholder = docImport.getFeaturePlaceholder(state, description, feature, true);
 					for (Reference<?> citation : refs) {
-						featurePlaceholder.addSource(null, null, citation, null);
+						featurePlaceholder.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, citation, null);
 					}
 				} else {
 					String message = "No reference found in references";
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupImportBase.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupImportBase.java
index 1d0b3beabb..d14d869e16 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupImportBase.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupImportBase.java
@@ -59,6 +59,7 @@ import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Extension;
 import eu.etaxonomy.cdm.model.common.ExtensionType;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
 import eu.etaxonomy.cdm.model.description.Distribution;
@@ -1033,7 +1034,7 @@ public abstract class MarkupImportBase  {
 			if (value.equals(GENUS_ABBREVIATION)){
 				rank = Rank.GENUS();
 			}else if (byAbbrev) {
-				rank = Rank.getRankByAbbreviation(value, nc, useUnknown);
+				rank = Rank.getRankByIdInVoc(value, nc, useUnknown);
 			} else {
 				rank = Rank.getRankByEnglishName(value, nc, useUnknown);
 			}
@@ -1088,7 +1089,7 @@ public abstract class MarkupImportBase  {
 	protected NomenclaturalCode makeNomenclaturalCode(MarkupImportState state) {
 		NomenclaturalCode nc = state.getConfig().getNomenclaturalCode();
 		if (nc == null) {
-			nc = NomenclaturalCode.ICBN; // default;
+			nc = NomenclaturalCode.ICNAFP; // default;
 		}
 		return nc;
 	}
@@ -1546,18 +1547,18 @@ public abstract class MarkupImportBase  {
 				}
 				// legend
 				if (StringUtils.isNotBlank(legendString)) {
-					media.addDescription(legendString, getDefaultLanguage(state));
+					media.putDescription(getDefaultLanguage(state), legendString);
 				}
 				if (StringUtils.isNotBlank(numString)) {
 					// TODO use concrete source (e.g. DAPHNIPHYLLACEAE in FM
 					// vol.13)
 					Reference<?> citation = state.getConfig().getSourceReference();
-					media.addSource(numString, "num", citation, null);
+					media.addSource(OriginalSourceType.Import, numString, "num", citation, null);
 					// TODO name used in source if available
 				}
 				// TODO which citation
 				if (StringUtils.isNotBlank(id)) {
-					media.addSource(id, null, state.getConfig().getSourceReference(), null);
+					media.addSource(OriginalSourceType.Import, id, null, state.getConfig().getSourceReference(), null);
 				} else {
 					String message = "Figure id should never be empty or null";
 					fireWarningEvent(message, next, 6);
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupKeyImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupKeyImport.java
index 1cd3726836..edbeb24bb9 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupKeyImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupKeyImport.java
@@ -353,7 +353,7 @@ public class MarkupKeyImport  extends MarkupImportBase  {
 
 	private boolean isInfraSpecificMarker(String single) {
 		try {
-			if (Rank.getRankByAbbreviation(single).isInfraSpecific()){
+			if (Rank.getRankByIdInVoc(single).isInfraSpecific()){
 				return true;
 			}else{
 				return false;
diff --git a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupNomenclatureImport.java b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupNomenclatureImport.java
index ee58d15ee8..c210f9576f 100644
--- a/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupNomenclatureImport.java
+++ b/cdmlib-io/src/main/java/eu/etaxonomy/cdm/io/markup/MarkupNomenclatureImport.java
@@ -24,6 +24,7 @@ import org.apache.log4j.Logger;
 import eu.etaxonomy.cdm.model.agent.INomenclaturalAuthor;
 import eu.etaxonomy.cdm.model.agent.TeamOrPersonBase;
 import eu.etaxonomy.cdm.model.common.CdmBase;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
 import eu.etaxonomy.cdm.model.common.TimePeriod;
 import eu.etaxonomy.cdm.model.description.Feature;
 import eu.etaxonomy.cdm.model.description.TaxonDescription;
@@ -45,6 +46,7 @@ import eu.etaxonomy.cdm.model.taxon.SynonymRelationshipType;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
 import eu.etaxonomy.cdm.strategy.exceptions.UnknownCdmTypeException;
 import eu.etaxonomy.cdm.strategy.parser.NameTypeParser;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
 
 /**
  * @author a.mueller
@@ -656,7 +658,7 @@ public class MarkupNomenclatureImport extends MarkupImportBase {
 			TaxonDescription td = getTaxonDescription(taxon, state.getConfig().getSourceReference(), false, true);
 			TextData citation = TextData.NewInstance(Feature.CITATION());
 			// TODO name used in source
-			citation.addSource(null, null, reference, microCitation);
+			citation.addSource(OriginalSourceType.PrimaryTaxonomicSource, null, null, reference, microCitation);
 			td.addElement(citation);
 		} else if (TYPE.equalsIgnoreCase(classValue)) {
 			handleNotYetImplementedAttributeValue(parentEvent, CLASS, classValue);
@@ -727,7 +729,7 @@ public class MarkupNomenclatureImport extends MarkupImportBase {
 		}
 
 		//year
-		TimePeriod timeperiod = TimePeriod.parseString(year);
+		TimePeriod timeperiod = TimePeriodParser.parseString(year);
 		if (reference.getType().equals(ReferenceType.BookSection)){
 			reference.getInBook().setDatePublished(timeperiod);
 		}
@@ -932,6 +934,7 @@ public class MarkupNomenclatureImport extends MarkupImportBase {
 		}
 	}
 
+
 	private boolean isArticle(String type, String volume, String editors) {
 		if ("journal".equalsIgnoreCase(type)){
 			return true;
